#!/usr/bin/env python
from sum import *

class Haus:
    def __init__(self):
        # Grundflaeche
        self.kasten = Rechteck()
        self.kasten.mittelpunkt = (100,100)
        self.kasten.breite = 50
        self.kasten.hoehe = 50
        self.kasten.fuellfarbe = blau
        self.kasten.linienfarbe = blau
        # Dach
        self.dach = Polygon()
        self.dach.setzePunkteliste([(65,75),(135,75),(100,40)])
        self.dach.fuellfarbe = rot
        self.dach.linienfarbe = rot
        # Tuer
        self.tuer = Rechteck()
        self.tuer.mittelpunkt = (100,115)
        self.tuer.hoehe = 20
        self.tuer.breite = 10
        self.tuer.fuellfarbe = gruen
        self.tuer.linienfarbe = gruen
    
    def zeichnen(self,gz):
        self.kasten.zeichnen(gz)
        self.dach.zeichnen(gz)
        self.tuer.zeichnen(gz)
    
    def verschiebeUm(self,vvek):
        self.kasten.verschiebeUm(vvek)
        self.dach.verschiebeUm(vvek)
        self.tuer.verschiebeUm(vvek)
    
    def dreheUm(self,winkel):
        self.kasten.dreheUm(winkel)
        self.dach.dreheUm(winkel)
        self.tuer.dreheUm(winkel)
    
    def gibFrei(self):
        self.kasten.gibFrei()
        self.dach.gibFrei()
        self.tuer.gibFrei()
    

class Gesicht:
    def __init__(self):
        self.kreis = Kreis()
        self.kreis.mpkt = (100,100)
        self.kreis.r = 50
        self.kreis.lf = gelb
        self.kreis.ls = 5
        self.kreis.ff = None
        self.auge1 = Ellipse()
        self.auge1.rx = 10
        self.auge1.ry = 5
        self.auge1.mpkt = (80,90)
        self.auge2 = Ellipse()
        self.auge2.rx = 10
        self.auge2.ry = 5
        self.auge2.mpkt = (120,90)
        self.mund = Bezierkurve()
        self.mund.sPkt([(80,100),(100,120),(120,100)])
        self.mund.sPkt([(80,120),(100,140),(120,120)])
        self.mund.ls = 5
        self.mund.lf = rot
    
    def zeichnen(self,gz):
        self.kreis.zeichnen(gz)
        self.auge1.zeichnen(gz)
        self.auge2.zeichnen(gz)
        self.mund.zeichnen(gz)
    
    def verschiebeUm(self,vvek):
        self.kreis.verschiebeUm(vvek)
        self.auge1.verschiebeUm(vvek)
        self.auge2.verschiebeUm(vvek)
        self.mund.verschiebeUm(vvek)
    
    def gibFrei(self):
        self.kreis.gibFrei()
        self.auge1.gibFrei()
        self.auge2.gibFrei()
        self.mund.gibFrei()
    

class Controler:
    def gerstellen(self):
        self.gesicht = Gesicht()
        appuifw.app.menu[0] = (u"Gesicht", (
                       (u"horiz. verschieben",self.gverschiebenH),
                       (u"vert. verschieben",self.gverschiebenV),
                       (u"loeschen",self.gloeschen)))
    
    def gverschiebenH(self):
        wert = appuifw.query(u"Horizontale Verschiebung um:",'number')
        if wert is not None: self.gesicht.verschiebeUm((wert,0))
    
    def gverschiebenV(self):
        wert = appuifw.query(u"Horizontale Verschiebung um:",'number')
        if wert is not None: self.gesicht.verschiebeUm((wert,0))
    
    def gloeschen(self):
        self.gesicht.gibFrei()
        appuifw.app.menu[0] = (u"Gesicht erstellen",self.gerstellen)
    
    def herstellen(self):
        self.haus = Haus()
        appuifw.app.menu[1] = (u"Haus", (
                       (u"horiz. verschieben",self.hverschiebenH),
                       (u"vert. verschieben",self.hverschiebenV),
                       (u"drehen",self.hdrehen),
                       (u"loeschen",self.hloeschen)))
    
    def hverschiebenH(self):
        wert = appuifw.query(u"Horizontale Verschiebung um:",'number')
        if wert is not None: self.haus.verschiebeUm((wert,0))
    
    def hverschiebenV(self):
        wert = appuifw.query(u"Horizontale Verschiebung um:",'number')
        if wert is not None: self.haus.verschiebeUm((wert,0))
    
    def hdrehen(self):
        wert = appuifw.query(u"Um Winkel:",'number')
        if wert is not None: self.haus.dreheUm(wert)
    
    def hloeschen(self):
        self.haus.gibFrei()
        appuifw.app.menu[1] = (u"Haus erstellen",self.herstellen)
    
    def setzeAnfangsmenu(self):
        appuifw.app.menu = [(u"Gesicht erstellen",self.gerstellen),
                    (u"Haus erstellen",self.herstellen)]
    

import appuifw
starteEinfachenModus()

c = Controler()
c.setzeAnfangsmenu()

# beenden verhindern
import e32
ao_lock = e32.Ao_lock()
def exithandler():
    ao_lock.signal()
appuifw.app.exit_key_handler = exithandler
ao_lock.wait()